local Theme = FlexBar2.OO.Mixin 
{

};


function Theme:Activate()
	--Actual button creation (note: not setting a NormalTexture here, an apart function does that which is called later on [at the icon creation part])
	self.Frame = FlexBar2.uiQuery("!CheckButton", "FB2_BTN_" .. self.uid, UIParent, "SecureActionButtonTemplate");
	
	-- Strata and sizing, drag registering
	self.Frame:SetFrameStrata("MEDIUM"):Size(36,36):RegisterForDrag("LeftButton");

	-- Textures setup
	self.Frame:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress"):SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight"):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");
	self.Frame:GetHighlightTexture():SetBlendMode("ADD");
	self.Frame:GetCheckedTexture():SetBlendMode("ADD")

	-- Icon setup
	self.Frame.Icon = self.Frame:CreateTexture(nil, "BACKGROUND"):SetAllPoints(self.Frame);

	-- Cooldown ticker setup
	self.Frame.Cooldown = FlexBar2.uiQuery("!Cooldown", nil, self.Frame, "CooldownFrameTemplate");
	self.LastCooldown = {};

	-- NormalTexture setup
	self.Frame:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
	local NormalTexture = self.Frame:GetNormalTexture();
	NormalTexture:SetWidth(60);
	NormalTexture:SetHeight(60);
	NormalTexture:ClearAllPoints();
	NormalTexture:SetPoint("CENTER", 1, -1);

	-- Button settings
	self.Frame:EnableMouse(true):SetClampedToScreen(true):SetMovable(true);
end

FlexBar2:RegisterButtonClass(Theme);
